Bug 1010398 - Executables that call ifuncs aren't prelinked on s390x
Executables that call ifuncs aren't prelinked on s390x
Product: Fedora
Classification: Fedora
Component: prelink (Show other bugs)
s390x Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Jakub Jelinek
Fedora Extras Quality Assurance
Depends On: 1013801
  Show dependency treegraph
Reported: 2013-09-20 13:08 EDT by Richard Sandiford
Modified: 2015-02-18 06:14 EST (History)
2 users (show)

See Also:
Fixed In Version: prelink-0.5.0-3.el7
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2015-02-18 06:14:03 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Suggested fix (2.29 KB, patch)
2013-09-20 13:08 EDT, Richard Sandiford
no flags Details | Diff

  None (edit)
Description Richard Sandiford 2013-09-20 13:08:16 EDT
Created attachment 800586 [details]
Suggested fix

Description of problem:

  If an executable has a PLT that calls an ifunc, the prelinker reports
  an error of the form "Conflict ... not found in any relocation"

Version-Release number of selected component (if applicable):


How reproducible:

  sudo prelink /usr/bin/ls

Actual results:

  prelink: /usr/bin/ls: Conflict 00000b78 not found in any relocation
  prelink: /usr/bin/ls: Conflict 00000938 not found in any relocation

Additional info:

  This seems to be caused by an early-out in s390_prelink_conflict_rela:

    if (GELF_R_TYPE (rela->r_info) == R_390_RELATIVE
        || GELF_R_TYPE (rela->r_info) == R_390_NONE
        || info->dso == dso)
      /* Fast path: nothing to do.  */
      return 0;

  where "info->dso == dso" means that relocations in the executable are
  ignored, even if against ifuncs.

  The attached patch structures the function in a similar way to x86_64.
  With this, no conflict errors are reported for "prelink -a".

  The patch makes the same change to 32-bit s390, but I haven't tested that.
Comment 1 Jakub Jelinek 2013-09-30 16:07:44 EDT
Looks correct, committed as r207 to prelink SVN.  Will try to add a testcase tomorrow.
Comment 2 Jakub Jelinek 2013-10-01 05:19:59 EDT
I've also committed s390 and s390x additions to testsuite/ifunc.h, with r207 reverted all the ifunc* tests FAIL on s390x, with r207 they all pass.
Comment 3 Fedora End Of Life 2015-01-09 17:35:52 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 4 Fedora End Of Life 2015-02-18 06:14:03 EST
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.